<?php
/**
* List bestsellers
* @return string
* @param string $sFile
*/
function listBestsellers( $sFile = null ){
  global $aList, $tpl;

  $aData = dbListBestsellers( );

  if( isset( $aData ) && is_array( $aData ) ){
    $iCount = count( $aData );
    $content= null;

    if( $iCount > 5 )
      $iCount = 5;
    for( $i = 0; $i < $iCount; $i++ ){
      list( $aList['iProduct'], $aList['sName'], $aList['fPrice'], $aList['sDescriptionShort'], $aList['iStatus'], $aList['iPosition'] ) = $aData[$i];
      
      $aList['i'] = $i + 1;
      $aList['iStyle'] = ( $i % 2 ) ? 0: 1;
      $aList['sStyle'] = ( $i == ( $iCount - 1 ) ) ? 'L': $i + 1;
      $aList['sNameUrl'] = change2Url( $aList['sName'] );

      $content .= $tpl->tbHtml( 'bestsellers.tpl', 'LIST' );
    } // end for

    if( isset( $content ) )
      return $tpl->tbHtml( 'bestsellers.tpl', 'HEAD' ).$content.$tpl->tbHtml( 'bestsellers.tpl', 'FOOT' );
  }
  else
    return null;
} // end function listBestsellers

/**
* List bestsellers from db
* @return array
*/
function dbListBestsellers( ){
  global $oFF;
  $aFile = file( DB_ORDERS );
  $iCount= count( $aFile );
  for( $i = 1; $i < $iCount; $i++ ){
    $aExp = explode( '$', $aFile[$i], 4 );
    if( $aExp[2] > 0 ){
      $aOrders[$aExp[0]] = true;
    }
  } // end for

  if( isset( $aOrders ) ){
    $aFile        = $oFF->throwFileArray( DB_PRODUCTS );
    $iCount       = count( $aFile );
    $aCategories  = dbThrowProductsCategories( );
    for( $i = 0; $i < $iCount; $i++ ){
      if( $aFile[$i][4] == 1 && isset( $aCategories[$aFile[$i][0]] ) )
        $aProducts[$aFile[$i][0]] = $aFile[$i];
    } // end for

    $aFile  = file( DB_ORDERS_PRODUCTS );
    $iCount = count( $aFile );
    for( $i = 1; $i < $iCount; $i++ ){
      $aExp = explode( '$', $aFile[$i] );
      if( isset( $aOrders[$aExp[1]] ) ){
        if( isset( $aData[$aExp[2]][0] ) ){
          $aData[$aExp[2]][0] += $aExp[3];
        }
        else{
          $aData[$aExp[2]][0] = $aExp[3];
          $aData[$aExp[2]][1] = $aExp[2];
        }
      }
    } // end for

    if( isset( $aData ) ){
      rsort( $aData );
      $iCount = count( $aData );
      $i2     = 0;
      for( $i = 0; $i < $iCount; $i++ ){
        if( isset( $aProducts[$aData[$i][1]] ) && $i2 < 5 ){
          $aReturn[] = $aProducts[$aData[$i][1]];
          $i2++;
        }
        else{
          if( $i2 == 5 ){
            break;
          }
        }
      } // end for
    }

    if( isset( $aReturn ) )
      return $aReturn;
  }
} // end function dbListBestsellers
?>